import vot
from vot import Rectangle

handle = vot.VOT("polygon")
Polygon = handle.region()

import sys
import cv2, torch
import numpy as np

from network.SiamFCOSP import SiamFCOSP_eval
from run_Siamfcos import SiamFCOS_init, SiamFCOS_track
from utils import get_axis_aligned_bbox, cxy_wh_2_rect

# load net
net = SiamFCOSP_eval()
net.load_state_dict(torch.load('SiamFCOSPlus_net_epoch15')['network'])
net.eval().cuda()

# start to track

cx, cy, w, h = get_axis_aligned_bbox(Polygon)

image_file = handle.frame()
if not image_file:
    sys.exit(0)

target_pos, target_sz = np.array([cx, cy]), np.array([w, h])
im = cv2.imread(image_file)  # HxWxC
state = SiamFCOS_init(im, target_pos, target_sz, net)  # init tracker
while True:
    image_file = handle.frame()
    if not image_file:
        break
    im = cv2.imread(image_file)  # HxWxC
    state = SiamFCOS_track(state, im)  # track
    res = cxy_wh_2_rect(state['target_pos'], state['target_sz'])

    handle.report(Rectangle(res[0], res[1], res[2], res[3]))

